# -*- coding: latin-1 -*-
'''
ping.py

Copyright 2007 Mariano Nuez Di Croce @ CYBSEC

This file is part of sapyto, http://www.cybsec.com/EN/research/tools/sapyto.php

sapyto is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

sapyto is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with sapyto; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'''
from core.basePlugins.basePlugin import basePlugin
import core.output.outputManager as om
import core.kb.knowledgeBase as kb
from saprfc import *
import saprfcutil
import re
from core.exceptions.dontRunException import dontRunException

class ping(basePlugin):
	'''
	Checks if remote RFC server is alive.
	
	@author: Mariano Nuez Di Croce <mnunez@cybsec.com>
	'''
	def __init__( self):
		basePlugin.__init__( self )
		self._iface = None
		self._targets = {}
		
	def run( self ):
		
		self._iface = iface('RFC_PING')
		status = False
		try:
			self._checkConnection()
		except sapytoException:
			om.out.information('System down.')
		else:
			try:
				if not saprfcutil.call_receive( self._conn, self._iface ):
					raise sapytoException('Could not perform RFC call.')
			except:
				om.out.information('System down.')
			else:
				om.out.information('System available.')
				self._conn.close()
				status = True
		return status
	
	
